Bug 996462 - Review Request: fix8 - Open Source C++ FIX Engine
Review Request: fix8 - Open Source C++ FIX Engine
Status: NEW
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
Depends On:
Blocks: F-ExcludeArch-ARM
  Show dependency treegraph
 
Reported: 2013-08-13 04:24 EDT by Christopher Meng
Modified: 2013-11-21 10:24 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Christopher Meng 2013-08-13 04:24:21 EDT
Spec URL: http://cicku.me/fix8.spec
SRPM URL: http://cicku.me/fix8-0.9.4-1.fc20.src.rpm
Description: Fix8 is a modern open source C++ FIX framework featuring complete schema 
driven customisation, high performance and fast application development.

Fix8 helps you get your FIX client or server up and running quickly. Using 
one of the standard FIX schemas you can have a FIX client or server up and 
running in next to no time.
Fedora Account System Username: cicku
Comment 1 Michael Simacek 2013-08-15 09:31:43 EDT
Provided links don't work
Comment 2 Christopher Meng 2013-08-28 06:37:17 EDT
(In reply to Michael Simacek from comment #1)
> Provided links don't work

Spec URL: http://cicku.me/fix8.spec
SRPM URL: http://cicku.me/fix8-0.9.4-1.fc21.src.rpm

Prior to that this library has problem with gcc.

Will you review it?
Comment 3 Michael Simacek 2013-08-31 11:17:22 EDT
I won't review it now because it doesn't build for me (amd64):
*** Error in `/home/msimacek/rpmbuild/BUILD/fix8-0.9.4/compiler/.libs/lt-f8c': double free or corruption (!prev): 0x00000000029b80f0 ***
Comment 4 David Dight 2013-09-01 03:06:03 EDT
(In reply to Michael Simacek from comment #3)
> I won't review it now because it doesn't build for me (amd64):
> *** Error in
> `/home/msimacek/rpmbuild/BUILD/fix8-0.9.4/compiler/.libs/lt-f8c': double
> free or corruption (!prev): 0x00000000029b80f0 ***

FYI builds on koji:
   http://koji.fedoraproject.org/koji/taskinfo?taskID=5878120

However this issue has just been reported here...
   https://groups.google.com/forum/#!topic/fix8-developer/FvuCxWd4Cw8
Comment 5 Christopher Meng 2013-09-08 06:02:15 EDT
(In reply to David Dight from comment #4)

So will you release 0.9.5 or give us a patch?
Comment 6 David Dight 2013-09-08 07:51:44 EDT
I am going to release 0.9.5 next Sunday. I'll send you a patch before then.

(In reply to Christopher Meng from comment #5)
> (In reply to David Dight from comment #4)
> 
> So will you release 0.9.5 or give us a patch?
Comment 7 David Dight 2013-09-22 00:21:18 EDT
Released Fix8 0.9.5:

SRPM URL: http://dl.bintray.com/dakka/rpm/fix8-0.9.5-220913.src.rpm
Comment 8 Christopher Meng 2013-09-22 21:57:37 EDT
Spec URL: http://cicku.me/fix8.spec
SRPM URL: http://cicku.me/fix8-0.9.5-1.fc21.src.rpm
Comment 9 Dan Horák 2013-09-26 03:39:25 EDT
Is there any technical reason for excluding ARM? If yes, then it should be excluded via %{arm}, not just armv7hl. And what about other arches - ppc or s390 or others?
Comment 10 David Dight 2013-09-26 03:45:03 EDT
We are working on an ARMv7 version. Yes, there are technical reasons - with our MPMC queues and use of atomic instructions. For now it made sense to exclude ARM.
Comment 11 Christopher Meng 2013-11-12 09:55:07 EST
0.10.0 out:

Spec URL: http://cicku.me/fix8.spec
SRPM URL: http://cicku.me/fix8-0.10.0-1.fc21.src.rpm
Comment 12 Orion Poplawski 2013-11-14 00:18:54 EST
Looks like it bundles the following from boost:

./include/yield.hpp: BSL (v1.0)
./include/coroutine.hpp: BSL (v1.0)

Can the system boost be used instead?

include/ff seems to be "FastFlow"


runtime/gzstream.cpp - LGPLv2+ http://www.cs.unc.edu/Research/compgeom/gzstream/

runtime/modp_numtoa.c - BSD - Nick Galbreath -- nickg [at] modp [dot] com

schema:
# These FIX xml schemas have been sourced from the QuickFix distribution with some minor
# modifications. These schemas are covered by the QuickFIX license below.
#############################################################################################
    
The QuickFIX Software License, Version 1.0
    
Copyright (c) 2001-2010 quickfixengine.org  All rights
reserved.
    
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
    
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
    
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in
   the documentation and/or other materials provided with the
   distribution.
    
3. The end-user documentation included with the redistribution,
   if any, must include the following acknowledgment:
      "This product includes software developed by
       quickfixengine.org (http://www.quickfixengine.org/)."
   Alternately, this acknowledgment may appear in the software itself,
   if and wherever such third-party acknowledgments normally appear.
    
4. The names "QuickFIX" and "quickfixengine.org" must
   not be used to endorse or promote products derived from this
   software without prior written permission. For written
   permission, please contact ask@quickfixengine.org
  
5. Products derived from this software may not be called "QuickFIX",
   nor may "QuickFIX" appear in their name, without prior written
   permission of quickfixengine.org
Comment 13 David Dight 2013-11-14 04:23:05 EST
The coroutine includes are very small and unlikely to change. It makes sense to include them in the package rather than add another dependency to the project.

Fastflow is included, and is LGPL. Additionally I have express permission from the author to include it in Fix8. gzstream is also LGPL. modp_numtoa is BSD which is a compatible license. The quickfix schemas are included with appropriate attribution and license inclusion.

Are you making some objection to their use/inclusion in the package? Please provide a little more information as to why these were mentioned.
Comment 14 Orion Poplawski 2013-11-14 10:22:44 EST
I understand that it makes it easier for your project, but Fedora as a distribution has the following policy:

https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries

Also, FastFlow seems to grab some other items as well.
Comment 15 David Dight 2013-11-14 21:31:39 EST
Ok understand now.
- I think the schemas would be ok under copylib - in fact the author of quickfix states in their documentation that users are free to copy and use them as they wish.
-gzstream, modp_itoa are all intended to be copied as well, copylib

-boost - we can change to an external dependency in fedora

-fastflow is not in fedora - if the authors do not wish to submit fastflow to fedora does this mean we would have to find an alternative because of the bundling rule?
Comment 16 Christopher Meng 2013-11-14 21:33:18 EST
(In reply to David Dight from comment #15)
> Ok understand now.
> - I think the schemas would be ok under copylib - in fact the author of
> quickfix states in their documentation that users are free to copy and use
> them as they wish.
> -gzstream, modp_itoa are all intended to be copied as well, copylib
> 
> -boost - we can change to an external dependency in fedora
> 
> -fastflow is not in fedora - if the authors do not wish to submit fastflow
> to fedora does this mean we would have to find an alternative because of the
> bundling rule?

Ok.

So I will package fastflow first.

Note You need to log in before you can comment on or make changes to this bug.